/* ex3.c	-- Yasuhiro Yamazaki Tue Oct 23 2001
 */
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdlib.h>

#include "cube.h"
#include "finger.h"

static void
setTranslate( const float *v )
{
  glTranslatef( v[0], v[1], v[2] );
}

static void
putHand( void )
{
  /* ѿ i  0:ƻ 1:ͺ 2: 3: 4: 򼨤 */
  int i;
  
  /* ƻؤΰ */
  float translate[5][3] ={
    {  4.0f, 1.0f, 0.0f },
    {  3.5f, 4.5f, 0.0f },
    {  1.4f, 4.5f, 0.0f },
    { -1.3f, 4.5f, 0.0f },
    { -3.2f, 4.5f, 0.0f }
  };

  /* ƻؤδĹ */
  float length[5]={ 2.0f, 2.0f, 2.2f, 2.1f, 1.9f };

  /* ƻؤδο */
  int joint[5]={ 2, 3, 3, 3, 3 };

  /* ƻؤˤĤơ줾δγ */
  float rotation[5][3]={
    { 20.0f, 80.0f,  0.0f },
    { 20.0f, 20.0f, 10.0f },
    { 40.0f, 40.0f, 20.0f },
    { 85.0f, 80.0f, 80.0f },
    { 85.0f, 85.0f, 85.0f }
  };

  /* ʿ褹 */
  glPushMatrix();
  glScalef( 4.5f, 4.5f, 1.0f );
  putCube();
  glPopMatrix();

  /* Ƥλؤ褹 */
  for( i=0; i<5; i++ ){
    glPushMatrix();
    if( i==0 ){
      /* ƻؤ֤ˤ */
      glRotatef( -60.0f, 0.0f, 0.0f, 1.0f );
    }
    setTranslate( translate[i] );
    putFinger( length[i], rotation[i], joint[i] );
    glPopMatrix();
  }
}

static void
displayCallback(void)
{
  glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

  putHand();
  
  glutSwapBuffers();
}

static void
reshapeCallback(int width, int height)
{
  glViewport(0, 0, width, height);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, width/(GLdouble)height, 0.01, 100);

  glMatrixMode(GL_MODELVIEW);
}

static void
keyboardCallback(unsigned char key, int x, int y)
{
  switch (key) {
  /*
  ** Esc줿ץλ
  */
  case 27:
    exit(EXIT_SUCCESS);
    break;
    
  default:
    break;
  }
}

static void
initGL(void)
{
  int width, height;

  width  = glutGet(GLUT_WINDOW_WIDTH);
  height = glutGet(GLUT_WINDOW_HEIGHT);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, width/(GLdouble)height, 0.01, 100);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(10.0, 10.0, 20.0, 0.0, 5.0, 0.0, 0.0, 1.0, 0.0);

  glClearColor(0.0, 0.0, 0.0, 1.0);
  glEnable(GL_DEPTH_TEST);
}

int
main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);

  glutCreateWindow("ex3 HAND");

  glutDisplayFunc(displayCallback);
  glutKeyboardFunc(keyboardCallback);
  glutReshapeFunc(reshapeCallback);
  
  initGL();
  
  glutMainLoop();
  
  return EXIT_SUCCESS;
}
