/* ex4.c	-- Yasuhiro Yamazaki Tue Oct 23 2001
 */
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "hand.h"
#include "handutility.h"

/* ɥξ֤򼨤 */
#define WINDOW_STATE_SHOW 0
#define WINDOW_STATE_HIDE 1

/* Static ѿ */
static HandModel *model = NULL; /* Υǥ */
static int windowState = WINDOW_STATE_SHOW; /* ɥξ */

/*  */
static void
initializeAll( void )
{
  if( model==NULL ){
    /* Υǥ */
    model = createHandModel();
    
    /* ʤߤˡhandutility.h ǤϲδؿѰդƤޤ
     * model = createHandModel2( HANDMODEL_TYPE_GU );
     *
     * Ǥ餫ᥰη򤷤ǥ뤬ޤ
     * HANDMODEL_TYPE_CHOKI
     * HANDMODEL_TYPE_PA
     * Ʊͤˡ祭ȥѡηǥեȤȤޤ
     * ʬǼηϡhandutility.c 򸫤Ʋ
     */

  } 
}

/*  */
static void
freeAll( void )
{
  if( model!=NULL ){
    destroyHandModel( model );
    model = NULL;
  }
}

/* ɽ */
static void
putHand( void )
{
  putHandModel( model );
}

/* 褬ɬפȤʤä˸ƤФ */
static void
displayCallback( void )
{
  glLoadIdentity();
  gluLookAt( 10.0, 10.0, 20.0, 0.0, 5.0, 0.0, 0.0, 1.0, 0.0 );

  glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );

  putHand();
  
  glutSwapBuffers();
}

/* ɥꥵ줿˸ƤФ */
static void
reshapeCallback( int width, int height )
{
  glViewport( 0, 0, width, height );

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 60.0, width/(GLdouble)height, 0.01, 100 );

  glMatrixMode( GL_MODELVIEW );
}

/* ɥϾƤФ */
static void
idleCallback( void )
{
  if( windowState==WINDOW_STATE_SHOW ){
    /* ɥ˹Ԥ򤳤˵ҤƲ */

    /* 褬ɬפʾϲΥȥȤ򳰤Ʋ */
    /* glutPostRedisplay(); */
  }
}

/* ɥ{ɽ/줿}˸ƤФ */
static void
visibilityCallback( int state )
{
  switch( state ){
  case GLUT_NOT_VISIBLE:
    fprintf( stderr, "THE WINDOW WAS HIDDEN.\n" );
    windowState = WINDOW_STATE_HIDE;
    break;
  case GLUT_VISIBLE:
    fprintf( stderr, "THE WINDOW WAS SHOWN.\n" );
    windowState = WINDOW_STATE_SHOW;
    break;
  }
}

/* ޥΥܥѲä˸ƤФ */
static void
mouseCallback( int button, int state, int x, int y )
{
  switch( button ){
  case GLUT_LEFT_BUTTON:
    fprintf( stderr, "LEFT BUTTON: " );
    break;
  case GLUT_MIDDLE_BUTTON:
    fprintf( stderr, "MIDDLE BUTTON: " );
    break;
  case GLUT_RIGHT_BUTTON:
    fprintf( stderr, "RIGHT BUTTON: " );
    break;
  }
  
  switch( state ){
  case GLUT_DOWN:
    fprintf( stderr, "DOWN\n" );
    break;
  case GLUT_UP:
    fprintf( stderr, "UP\n" );
    break;
  }
}

/* ޥΥݥ󥿤ưä˸ƤФ */
static void
passiveMotionCallback( int x, int y )
{
  fprintf( stderr, "MOUSE (%d, %d)\n", x, y );
}

/* ɥå桢ޥΥݥ󥿤ưä˸ƤФ */
static void
motionCallback( int x, int y )
{
  fprintf( stderr, "DRAG (%d, %d)\n", x, y );
}

/* Ϥä˸ƤФ */
static void
keyboardCallback( unsigned char key, int x, int y )
{
  fprintf( stderr, "HIT \'%c\' KEY (CODE: %d)\n", (key<32)?'?':key, (int)key );

  switch( key ){
  /*
  ** Esc줿ץλ
  */
  case 27:
    exit( EXIT_SUCCESS );
    break;
    
  default:
    break;
  }
}

/*  */
static void
initGL( void )
{
  int width, height;

  width  = glutGet( GLUT_WINDOW_WIDTH );
  height = glutGet( GLUT_WINDOW_HEIGHT );

  reshapeCallback( width, height );

  glClearColor( 0.0, 0.0, 0.0, 1.0 );
  glEnable( GL_DEPTH_TEST );
}

/* MAIN */
int
main( int argc, char *argv[] )
{
  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH );

  glutCreateWindow( "ex4 HAND ANIMATION" );

  glutDisplayFunc( displayCallback );
  glutKeyboardFunc( keyboardCallback );
  glutReshapeFunc( reshapeCallback );
  glutIdleFunc( idleCallback );
  glutVisibilityFunc( visibilityCallback );
  glutMouseFunc( mouseCallback );
  glutPassiveMotionFunc( passiveMotionCallback );
  glutMotionFunc( motionCallback );
  
  initGL();
  initializeAll();
  
  glutMainLoop();

  freeAll();
  
  return EXIT_SUCCESS;
}
