/* finger.c	-- Yasuhiro Yamazaki Tue Oct 23 2001
 */

#include <stdio.h>
#include <GL/gl.h>
#include "finger.h"

/* ƵŪ˻ѥ᡼ǻؤΥǥɽ */
void 
putFinger( const float length, const float *rotation, const int howmany )
{
  glPushMatrix();
  glRotatef( *rotation, 1.0f, 0.0f, 0.0f );
  glTranslatef( 0.0f, length, 0.0f );
  glPushMatrix();
    glScalef( 1.0f, length, 1.0f );
    putCube();
  glPopMatrix();
  glTranslatef( 0.0f, length, 0.0f );

  if( howmany>1 ){
    putFinger( length, ++rotation, howmany-1 );
  }
  glPopMatrix();
}

/* ؤ */
FingerModel *
createFingerModel( void )
{
  int i;
  
  FingerModel *ret = (FingerModel *)malloc( sizeof( FingerModel ) );
  ret->translate.x = 0.0f;
  ret->translate.y = 0.0f;
  ret->translate.z = 0.0f;
  ret->length      = 1.0f;
  ret->joint       = 3;
  ret->rotation_z  = 0.0f;
  ret->rotation_x  = (float *)malloc( ret->joint * sizeof( float ) );
  for( i=0; i<ret->joint; i++ ){
    ret->rotation_x[i] = 0.0f;
  }

  return ret;
}

/* ؤѴ */
void 
destroyFingerModel( FingerModel *model )
{
  if( model->rotation_x!=NULL ) free( model->rotation_x );
  free( model );
}

/* ؤɽ */
void 
putFingerModel( const FingerModel *model )
{
  glPushMatrix();
  glTranslatef( model->translate.x, model->translate.y, model->translate.z );
  glRotatef( model->rotation_z, 0.0f, 0.0f, 1.0f );
  putFinger( model->length, model->rotation_x, model->joint );
  glPopMatrix();
}

/* ؤξɽ */
void 
printFingerModel( FILE *stream, const FingerModel *model )
{
}

/* Υǥؿ */
void 
setFingerModelPosition( FingerModel *model, 
			const float x, const float y, const float z )
{
  model->translate.x = x;
  model->translate.y = y;
  model->translate.z = z;
}

void 
setFingerModelLength( FingerModel *model, const float length )
{
  model->length = length;
}

void 
setFingerModelNumOfJoint( FingerModel *model, const int joint )
{
  float *rx, *src, *dst;
  int min_size, i;
  
  min_size = (joint<model->joint)?joint:model->joint;

  rx = (float *)malloc( joint * sizeof( float ) );
  dst = rx;
  src = model->rotation_x;
  for( i=0; i<min_size; i++ ){
    *dst++ = *src++;
  }
  for( i=0; i<joint-min_size; i++ ){
    *dst++ = 0.0f;
  }
  free( model->rotation_x );

  model->joint = joint;
  model->rotation_x = rx;
}

void 
setFingerModelJointRotation( FingerModel *model,
			     const int joint, const float rotation )
{
  if( joint>=0 && joint<model->joint ){
    model->rotation_x[ joint ] = rotation;
  }
}

void 
setFingerModelRotation( FingerModel *model, const float rotation )
{
  model->rotation_z = rotation;
}

/* Υǥξؿ */
float
getFingerModelJointRotation( FingerModel *model, const int joint )
{
  float ret = 0.0f;
  if( joint>=0 && joint<model->joint ){
    ret = model->rotation_x[ joint ];
  }
  return ret;
}

/* ǥƱΤ */
void
interpolationFingerModel( FingerModel *dst,
			  const FingerModel *src0, const FingerModel *src1,
			  const float rate )
{
  /*
   *  rate (0.0f-1.0f) δ֤˱֤Ǥ褦ˤƤ
   *
   * 0.0f:     *dst  *src0 Ʊͤˤʤޤ
   * 1.0f:     *dst  *src1 Ʊͤˤʤޤ
   * ʳ: *dst Ϥγ˱ *src0  *src1 δ֤ͤˤʤޤ
   */
}
