/* finger.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _FINGER_H
#define _FINGER_H

#include <stdio.h>
#include "vector3d.h"

/* ¤ */
typedef struct tagFingerModel 
{
  /* ƻؤΰ */
  Vector3D translate;

  /* ƻؤδĹ */
  float length;

  /* ƻؤδο */
  int joint;
  
  /* ƻؤˤĤơ줾δγ */
  float *rotation_x;

  /* ƻؤγˤĤƤγ */
  float rotation_z;

} FingerModel;

/* ؤ */
FingerModel *createFingerModel( void );

/* ؤѴ */
void destroyFingerModel( FingerModel * );

/* ؤɽ */
void putFingerModel( const FingerModel * );

/* ѥ᡼ǥǥɽ */
void putFinger( const float length, const float *rotation, const int howmany );

/* ؤξɽ */
void printFingerModel( FILE *, const FingerModel * );

/* Υǥؿ */
void setFingerModelPosition( FingerModel *,
			     const float x, const float y, const float z );
void setFingerModelLength( FingerModel *, const float length );
void setFingerModelNumOfJoint( FingerModel *, const int joint );
void setFingerModelJointRotation( FingerModel *, const int joint, 
				  const float rotation );
void setFingerModelRotation( FingerModel *, const float rotation );

/* Υǥξؿ */
float getFingerModelJointRotation( FingerModel *, const int joint );

/* ǥƱΤ */
void interpolationFingerModel( FingerModel *model,
			       const FingerModel *src0, const FingerModel *src1, 
			       const float rate );

#endif
