/* hand.h	-- Yasuhiro Yamazaki
 *
 * $Header$
 * $Log$
 */

#ifndef _HAND_H
#define _HAND_H

#include <stdio.h>
#include "finger.h"

#define HAND_MODEL_FINGER_MAX 5

/* ¤ */
typedef struct tagHandModel 
{
  /* ؤο */
  int howmany;

  /* ƻؤξ */
  FingerModel **finger;

} HandModel;

/* Υǥ */
HandModel *createHandModel( void );

/* ΥǥѴ */
void destroyHandModel( HandModel * );

/* Υǥɽ */
void putHandModel( const HandModel * );

/* Υǥͤɽ */
void printHandModel( FILE *, const HandModel * );

/* Υǥؿ */
void setHandModelFingerPosition( HandModel *, const int no, 
				 const float x, const float y, const float z );
void setHandModelFingerLength( HandModel *, const int no, const float length );
void setHandModelFingerNumOfJoint( HandModel *, const int no, const int joint );
void setHandModelFingerJointRotation( HandModel *, const int no, 
				      const int joint, const float rotation );
void setHandModelFingerRotation( HandModel *, const int no, const float rotation );
void setHandModelFinger( HandModel *, const int no, FingerModel * );
void setHandModelNumOfFinger( HandModel *, const int howmany );

/* ؿ */
FingerModel *getHandModelFinger( HandModel *, const int no );

/* ֥ǥ׻ؿ */
void interpolationHandModel( HandModel *, 
			     const HandModel *, const HandModel *,
			     const float rate );

#endif
