/* handutility.c	-- Yasuhiro Yamazaki Sun Oct 28 2001
 */
#include <stdio.h>
#include "hand.h"
#include "handutility.h"

/* λ̤μѲ */
static void
modifyHandModel( HandModel *model, 
		 const float init_rotation_x[5][3],
		 const float init_rotation_z[5] )
{
  int i, j;
  for( i=0; i<5; i++ ){
    setHandModelFingerRotation( model, i, init_rotation_z[i] );
    for( j=0; j<model->finger[i]->joint; j++ ){
      setHandModelFingerJointRotation( model, i, j, init_rotation_x[i][j] );
    }
  }
}

/*  */
static void
modifyHandModel_GU( HandModel *model )
{
  const float init_rotation_x[ 5 ][ 3 ]={
    { 95.0f, 95.0f,  0.0f },
    { 85.0f, 80.0f, 70.0f },
    { 85.0f, 80.0f, 75.0f },
    { 85.0f, 80.0f, 80.0f },
    { 85.0f, 85.0f, 85.0f }
  };
  const float init_rotation_z[ 5 ]={ -90.0f, -5.0f, 0.0f, 5.0f, 10.0f };

  modifyHandModel( model, init_rotation_x, init_rotation_z );
}

/* 礭 */
static void
modifyHandModel_CHOKI( HandModel *model )
{
  const float init_rotation_x[ 5 ][ 3 ]={
    { 105.0f, 85.0f,  0.0f },
    {   0.0f,  5.0f,  0.0f },
    {   0.0f,  5.0f,  0.0f },
    {  85.0f, 80.0f, 80.0f },
    {  85.0f, 85.0f, 85.0f }
  };
  const float init_rotation_z[ 5 ]={ -90.0f, -5.0f, 0.0f, 5.0f, 10.0f };

  modifyHandModel( model, init_rotation_x, init_rotation_z );
}

/* ѡ */
static void
modifyHandModel_PA( HandModel *model )
{
  const float init_rotation_x[ 5 ][ 3 ]={
    { -5.0f, 0.0f, 0.0f },
    {  0.0f, 5.0f, 0.0f },
    {  0.0f, 5.0f, 0.0f },
    {  0.0f, 5.0f, 0.0f },
    {  0.0f, 0.0f, 0.0f }
  };
  const float init_rotation_z[ 5 ]={ -60.0f, -5.0f, 0.0f, 5.0f, 10.0f };

  modifyHandModel( model, init_rotation_x, init_rotation_z );
}

/* ̤Υǥ */
HandModel *
createHandModel2( const int type )
{
  HandModel *ret = createHandModel(); /* ܥǥ */
  
  switch( type ){
  case HANDMODEL_TYPE_GU:
    modifyHandModel_GU( ret );
    break;
  case HANDMODEL_TYPE_CHOKI:
    modifyHandModel_CHOKI( ret );
    break;
  case HANDMODEL_TYPE_PA:
    modifyHandModel_PA( ret );
    break;
  }

  return ret;
}

