/* shower.c	-- Yasuhiro Yamazaki Thu Nov 23 2000
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <GL/gl.h>
#include <GL/glut.h>

/* ɥΥǥեȥ */
#define DEFAULT_WIDTH  400
#define DEFAULT_HEIGHT 400

/* ˥塼μ */
#define MENU_NONE 0
#define MENU_QUIT 1

/* ʮ */
#define SPAWN     64

/* ɥѤѿ */
static GLsizei windowWidth = DEFAULT_WIDTH, windowHeight = DEFAULT_HEIGHT;
static int mouseX, mouseY, pushButton = 0;

/* Ĥξ */
typedef struct tagPARTICLE
{
  float x, y;
  float vx, vy;
  float t;
} PARTICLE;

/* ξ󥯥ꥹ */
typedef struct tagPARTICLE_LIST
{
  PARTICLE particle;
  struct tagPARTICLE_LIST *prev, *next;
} PARTICLE_LIST;

/* 󥯥ꥹȤΥȥ꡼ݥ */
static PARTICLE_LIST *entry = NULL;

/* 󥯥ꥹȤɲä */
void
entryNewParticle( const float x, const float y )
{
  PARTICLE_LIST *add = (PARTICLE_LIST *)malloc( sizeof( PARTICLE_LIST ) );
  add->particle.x  = x;
  add->particle.y  = y;
  add->particle.vx = drand48()*8.0f-4.0f;
  add->particle.vy = drand48()*8.0f-4.0f;
  add->particle.t  = 0.0f;
  
  add->next = entry;
  if( entry!=NULL ) entry->prev = add;
  add->prev = NULL;
  
  entry = add;
}

/* ꥹȤ */
void
removeParticle( PARTICLE_LIST *pl )
{
  if( pl==entry ) entry = pl->next;
  else if( pl->prev!=NULL ) (pl->prev)->next = pl->next;
  if( pl->next!=NULL ) (pl->next)->prev = pl->prev;
  free( pl );
}

/* ˤϥɥ֤ν񤭤ޤ */
void 
myIdle( void )
{
  int i;
  float dt = 0.001f; /* ʤ󤫤λֺʬäƤ٤ */
  PARTICLE_LIST *here;

  glClearColor( 0.0, 0.0, 0.0, 0.0 );
  glClear( GL_COLOR_BUFFER_BIT );

  glBegin( GL_POINTS );
  glColor3f( 1.0f, 1.0f, 1.0f );

  /* ꥹȤéäƤγҤư褹 */
  here = entry;
  while( here!=NULL ){
    PARTICLE *p = &here->particle;

    p->t += dt;

    glVertex2f( p->x + p->vx*p->t, p->y + p->vy*p->t );

    if( p->t > 0.1f ){ /* γҤμ̿褿ä */
      PARTICLE_LIST *keep = here->next;
      removeParticle( here );
      here = keep;
    } else here = here->next;
  }

  glEnd();

  glutSwapBuffers();
  glFlush();

  /* åƤ鿷γҤФ */
  if( pushButton==1 )
    for( i=0; i<SPAWN; i++ )
      entryNewParticle( (float)mouseX/(float)windowWidth-0.5f, 
			0.5f-(float)mouseY/(float)windowHeight );
  return;
}

/* ˴ؤϤ˽񤭤ޤ */
void 
myDisplay( void )
{
  return;
}

/* ޥ˴ؤϤ˽񤭤ޤ */
void 
handleMouse( int click, int state, int x, int y )
{
  switch( click ){

  case GLUT_LEFT_BUTTON:  /* ܥΥå */
    if( state==GLUT_UP ) pushButton = 0;
    else pushButton = 1;
    break;

  default:
    break;
  }

  mouseX = x;
  mouseY = y;
  return;
}
void
handleMotion( int x, int y )
{
  mouseX = x;
  mouseY = y;
}

/* ܡɤΥ줿νϤ˽񤭤ޤ */
void 
myKeyboard( unsigned char key, int x, int y )
{
  switch( key ){
  case 27: /* ESC key code */
    exit(0);
    break;
  default:
    break;
  }

  return;
}

/* ˥塼Ф줿νϤ˽񤭤ޤ */
void 
menuSelect( int value )
{
  switch( value ){ /* Ф줿˥塼ֹ椬֤ޤ */
    case MENU_QUIT:
      exit(0);
      break;

    default:
      break;
    };

  glutPostRedisplay();
  return;
}

/* Ļ */
void 
myVisibility( int status )
{
  if( status==GLUT_VISIBLE ) glutIdleFunc(myIdle);
  else glutIdleFunc(NULL);
}

/* ɥΥ줿ν */
void
myReshape( GLsizei w, GLsizei h )
{
  glViewport( 0, 0, w, h );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();

  gluOrtho2D( -0.5f, 0.5f, -0.5f, 0.5f );

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  windowWidth = w;
  windowHeight = h;

  return;
}

/* ᥤؿ */
int 
main( int argc, char **argv )
{
  srand48( time(NULL) );

  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB );
  glutInitWindowSize( DEFAULT_WIDTH, DEFAULT_HEIGHT );
  glutCreateWindow( "Demo: Event/Animation" );

  /* ƥ٥Ȥбؿ򤳤ǻꤷƤ */
  glutDisplayFunc      ( myDisplay    );
  glutVisibilityFunc   ( myVisibility );
  glutReshapeFunc      ( myReshape    );
  glutMouseFunc        ( handleMouse  );
  glutMotionFunc       ( handleMotion );
  glutKeyboardFunc     ( myKeyboard   );

  /* ˥塼ޤ */
  glutCreateMenu( menuSelect );
  glutAddMenuEntry( "Demo: Event/Animation", MENU_NONE );
  glutAddMenuEntry( "Quit", MENU_QUIT );

  /* ޥαܥǥ˥塼ɽޤ */
  glutAttachMenu( GLUT_RIGHT_BUTTON );

  /* ¹ */
  glutMainLoop();
  return 0;
}

