/* vector3d.c	-- Yasuhiro Yamazaki Wed Oct 24 2001
 */
#include <stdio.h>
#include <stdlib.h>
#include "vector3d.h"

/*  */
Vector3D *
createVector3D( void )
{
  Vector3D *ret = (Vector3D *)malloc( sizeof( Vector3D ) );
  ret->x = 0.0f;
  ret->y = 0.0f;
  ret->z = 0.0f;
  return ret;
}

Vector3D *
createVector3Df( const float x, const float y, const float z )
{
  Vector3D *ret = createVector3D();
  setVector3DCoordinatef( ret, x, y, z );
  return ret;
}

Vector3D *
createVector3Dv( const float *v )
{
  Vector3D *ret = createVector3D();
  setVector3DCoordinatev( ret, v );
  return ret;
}

/*  */
Vector3D *
croneVector3D( const Vector3D *v )
{
  Vector3D *ret = createVector3D();
  copyVector3D( ret, v );
  return ret;
}

/* ˴ */
void 
destroyVector3D( Vector3D *v )
{
  free( v );
}

/* ͤ */
void 
setVector3DCoordinatef( Vector3D *v, const float x, const float y, const float z )
{
  v->x = x;
  v->y = y;
  v->z = z;
}

void 
setVector3DCoordinatev( Vector3D *v, const float *f )
{
  v->x = *f++;
  v->y = *f++;
  v->z = *f;
}

void
copyVector3D( Vector3D *v, const Vector3D *from )
{
  v->x = from->x;
  v->y = from->y;
  v->z = from->z;
}

